﻿<?php
/*
==============================================
Файл: api.class.php
==============================================
Назначение: класс для работы с uCoz API
==============================================
(c) 2009-2011 php4.ucoz.ru
==============================================
*/
if(!$cacheapi){
	require_once "db/db.class.php";
	$cacheapi = new dbase();
	$cacheapi->connect("db/api.cache.txt");
}
if(!$global) require_once "configs/global.config.php";
$now = time();
$last_cleared = $cacheapi->select("cache_cleared", "`t` = '1'", "");
$last_cleared = $last_cleared[0][date];
if($global[cacheupdate] < 1) $global[cacheupdate] = 1; //А это для особо умных, которые не думают о безопасности скрипта!
if($last_cleared < $now - 60*60*$global[cacheupdate]){
	//Чистка кэша происходит раз в 24 часа
	$cacheapi->create("api_users", array(
		"USER_ID" => "text",
		"USER_PROFILE" => "text",
		"USER_GROUPID" => "text",
		"USER_GROUPNAME" => "text",
		"USER_USERNAME" => "text",
		"USER_NAME" => "text",
		"USER_GENDER" => "text",
		"USER_AVATAR" => "text",
		"USER_EMAIL" => "text",
		"USER_ISVERIFIEDEMAIL" => "text",
	
		"USER_HOMEPAGE" => "text",
		"USER_COUNTRY" => "text",
		"USER_CITY" => "text",
		"USER_ICQ" => "text",
		"USER_AOL" => "text",
		"USER_MSN" => "text",
		"USER_YAHOO" => "text",
		"USER_BIRTHDAY" => "text",
		"USER_ZODIAC" => "text",
		"USER_AGE" => "text",
		
		"USER_IPADDRESS" => "text",
		"USER_BANNEDTILL" => "text",
		"USER_RANK" => "text",
		"USER_RANKNAME" => "text",
		"USER_REPUTATION" => "text",
		"USER_AWARDS" => "text",
		"USER_REGTIMESTAMP" => "text",
		"USER_LOGTIMESTAMP" => "text",
		"USER_STATUS" => "text",
		"USER_UNETPROFILE" => "text",
		
		"USER_UNETID" => "text",
	));
	$cacheapi->update("cache_cleared", array(
		'date' => $now,
	), "`t` = '1'");
}
class api{
	var $apikey;
	var $apiurl;
	function __construct($apikey){
		$this->apikey = $apikey;
		$this->apiurl = "http://" . $_SERVER['HTTP_HOST'] . "/api/";
	}
	function toarray($doc, $keys, $values){
		//Простите за сложность решения, лучше пока не нашёл
		$keys = $doc->getElementsByTagName($keys);
		$values = $doc->getElementsByTagName($values);
		foreach($keys as $node) $arrayk[] = $node->nodeValue;
		foreach($values as $node) $arrayv[] = $node->nodeValue;
		$arrayv = array_slice($arrayv, 1);
		foreach ($arrayk as $key => $value) $array[$value] = $arrayv[$key];
		return $array;
	}
	function getuser($id){
		//Получает данные пользователя по id
		$cacheapi = $GLOBALS[cacheapi];
		if(strlen($id) <= 8 && $id != 0){
			unset($res);
			$res = $cacheapi->select("api_users", "`USER_ID` = '$id'", "");
			if(!$res){
				$doc = new DOMDocument();
				$result = @$doc->load($this->apiurl . 'index/8-' . $id . '?apikey=' . $this->apikey);
				if(!$result) die("Невозможно подключится к api! Превышен лимит запросов.");
				$array = $this->toarray($doc, "name", "value");
				$cacheapi->insert("api_users", $array); //Кэширование запроса к api
			}else{
				//Вывод информации из кэша
				foreach($res as $key => $value) $array = $res[$key];
			}
			return $array;
		}
		//Для гостей
		$a = array(
			'USER_ID'		=> 0,
			'USER_PROFILE'	=> '',
			'USER_USERNAME' => 'Гость',
			'USER_GROUPID'	=> 0,
			'USER_NAME'		=> 'Гость',
			'USER_GROUPNAME'=> 'Гости',
			'USER_AVATAR'	=> 0,
		);
		return $a;
	}
}
$api = new api("v2Xm8UsTkBSyV8uG");
?>