<?php
/*
==============================================
Файл: db.class.php
==============================================
Назначение: класс для работы с текстовой БД
==============================================
(c) 2009-2011 php4.ucoz.ru
==============================================
*/
class dbase{
	var $_last;
	var $dbase;
	var $file;
	function _($v1=null,$v2=null,$v3=null,$v4=null,$v5=null,$v6=null,$v7=null,$v8=null,$v9=null,$v10=null){
		//Повторяет предыдущую функцию
		eval($this->_last);
		return $this;
	}
	function connect($file){
		//Открывает базу данных
		$json = "";
		$this->file = $file;
		$db = fopen($file, "r");
		if(!$db){
			sleep(1);
			$this->connect($this->file);
			return;
		}
		flock($db, LOCK_EX);
		while(!feof($db)) $json .= fgets($db);
		flock($db, LOCK_UN);
		fclose($db);
		$this->dbase = json_decode($json, true);
	}
	function dbupdate(){
		//Обновляет базу данных
		$db = fopen($this->file, "w");
		if(!$db){
			sleep(1);
			$this->dbupdate();
			return;
		}
		flock($db, LOCK_EX);
		fwrite($db, json_encode($this->dbase));
		flock($db, LOCK_UN);
		fclose($db);
	}
	function create($table, $struct){
		//Создание таблицы
		$this->_last = "$this->create($v1, $v2);";
		$this->dbase[$table] = array("__struct" => $struct);
		$this->dbupdate();
		return $this;
	}
	function insert($table, $values){
		//Вставка в таблицу
		$this->_last = "$this->insert($v1, $v2);";
		$maxk = 0;
		if(!$this->dbase[$table]) return;
		foreach($this->dbase[$table] as $key => $value) if($key > $maxk) $maxk = $key;
		$rows = $maxk + 1;
		if(!$this->dbase[$table]["__struct"]) return;
		foreach($this->dbase[$table]["__struct"] as $key => $value){
			if(strpos($value, "auto_increment") !== false && !$values[$key]){
				$values[$key] = $rows;
			}			
		}
		if($values[$key] == "NOW()") $values[$key] = time();
		$this->dbase[$table][$rows] = $values;
		$this->dbupdate();
		return $this;
	}

	function select($from, $where = "", $orderby = 0, $orderto = 0, $limitb = 0, $limite = 0, $delete = false){
		//Выборка из таблицы
		$result = $this->dbase[$from];
		if(!$result) return;
		$result = array_slice($result, 1); //Убираем структурные значения
		if($where){
			//Выборка, как в SQL (упрощённая, поддерживает только сравнивание)
			$where = preg_replace("|`([^`]+)`|Uis", '$result[$key][\'\\1\']', $where);
			$where = str_replace("=", "==", $where);
			$where = str_replace(">==", ">=", $where);
			$where = str_replace("<==", "<=", $where);
			$where = str_replace("====", "===", $where);
			$cond = "if(!($where)) unset(".'$result[$key]'.");";
			foreach($result as $key => $value){
				eval($cond);
			}
		}
		if($orderby){
			//Сортировка
			$code = "return strnatcmp(\$a['$orderby'], \$b['$orderby']);";
			if($orderto == "DESC") usort($result, create_function('$b,$a', $code));
			else usort($result, create_function('$a,$b', $code));
		}
		if($limite) $result = array_slice($result, $limitb, $limite); //Ограничение на вывод строк
		if($delete){
			$not_result = $this->dbase[$from];
			$not_result = array_slice($not_result, 1);
			foreach($not_result as $key => $value){
				if($not_result[$key] != $result[$key]) unset($this->dbase[$from][$key]);
			}
			$this->dbupdate();
		}
		return $result;
	}
	function update($table, $set, $where = null){
		//Обновление таблицы
		$this->_last = "$this->update($v1, $v2, $v3);";
		if($where){
			$where = preg_replace("|`([^`]+)`|Uis", '$result[$key][\'\\1\']', $where);
			$where = str_replace("=", "==", $where);
			$where = str_replace(">==", ">=", $where);
			$where = str_replace("<==", "<=", $where);
			$where = str_replace("====", "===", $where);
			foreach ($set as $k => $v){
				$cond .= "if(($where)) ".'$this->dbase[$table][$key]'."[$k] = '$v';";
			}
		}else $cond .= '$this->dbase[$table][$key]'."[$k] = '$v';";
		$result = $this->dbase[$table];
		if(!$result) return;
		foreach($result as $key => $value){
			eval($cond);
		}
		$this->dbupdate();
		return $this;
	}
}
?>