﻿<?php
/*
============================================
 php4.ucoz.ru 
--------------------------------------------
 Copyright (c) 2011 High-Five 
============================================
 Файл: tpl.class.php
--------------------------------------------
 Назначение: Класс для работы с шаблонами
============================================
*/
class tpl{
	var $dir;
	var $html;
	var $sets = array();
	var $codepage;
	var $_last;
	public $sub;
	function _($v1 = null, $v2 = null){
		/*Повторяет предыдущую функцию. Необходима для цепочек вида
		$tpl->set('{value1}', $value1)
			->	_('{value2}', $value2) //равносильно ->set('{value2}', $value2)
		*/
		eval($this->_last);
		return $this;
	}
	function dir($dir){
		#Назначает директорию шаблонов
		$this->dir = $dir;
		return $this;
	}
	function load($tpl, $codepage="UTF-8"){
		#Подгружает главный шаблон
		$fd = fopen($this->dir . "/" . $tpl, "r");
		if(!$fd) die("Не найден шаблон" . $this->dir . "/" . $tpl);
		while(!feof($fd)){
			$this->html .= fgets($fd, 4096);
		}
		fclose($fd);
		$this->codepage = $codepage;
		return $this;
	}
	function set($var, $value){
		#Устанавливает {коды} в шаблоне
		$this->_last = '$this->set($v1, $v2);';
		$this->sets[$var] = $value;
		return $this;
	}
	function hide($start, $end){
		#Удаляет текст между [началом] и [/концом]
		$this->_last = '$this->hide($v1, $v2);';
		$start = str_replace("[", "\\[", $start);
		$start = str_replace("]", "\\]", $start);
		$start = str_replace("=", "\\=", $start);
		$end = str_replace("[", "\\[", $end);
		$end = str_replace("]", "\\]", $end);	
		$this->html = preg_replace("#".$start."(.*)".$end."#Usi", "", $this->html);
		return $this;
	}
	function add($var, $url){
		#Подгружает дополнительные шаблоны
		$this->_last = '$this->add($v1, $v2);';
		$this->sub[$var] = new tpl;
		$this->sub[$var]->dir($this->dir)
						->load($url, $this->codepage);
		return $this;
	}
	function before($string, $text){
		$this->_last = '$this->before($v1, $v2);';
		$this->html = str_replace($text, $string . $text, $this->html);
		return $this;
	}
	function after($string, $text){
		$this->_last = '$this->after($v1, $v2);';
		$this->html = str_replace($text, $text . $string, $this->html);
		return $this;
	}
	function replace($from, $to){
		$this->html = str_replace($from, $to, $this->html);
		return $this;
	}
	function compile(){
		#Компилирует шаблон
		if(count($this->sub)){
			foreach ($this->sub as $var => $value){
				$this->sub[$var]->compile();
				$this->html = str_replace($var, $value->html, $this->html);
			}
		}
		foreach ($this->sets as $var => $value){
			$this->html = str_replace($var, $value, $this->html);
		}
		return $this;
	}
}
$tpl = new tpl;

?>